import es
import cmdlib
import popuplib
import playerlib
import vecmath
import time
import random
from gamethread import queue
from gamethread import delayed
from os import path
import psyco
psyco.full()

info = es.AddonInfo()
info.name = "Universal Soccer Script"
info.version = "2.32"
info.url = "http://addons.eventscripts.com/addons/view/soccer"
info.basename = "soccer"
info.author = "chrismrulz"
es.set('uss_version', info.version)
es.makepublic('uss_version')
spawn_time = 0
spawn_queue = []
timer = 0

def optionssay(userid, args):
	popups['optionsmenu'].send(userid)

def navmenu(userid, choice, popupname):
	popups[popupname].unsend(userid)
	popups[choice.replace('goto', '')].send(userid)

def setoption(userid, choice, popupname):
	if(str(choice).startswith('goto')):
		navmenu(userid, choice, popupname)
	else:
		steamid = es.getplayersteamid(userid)
		global players
		if(steamid not in players):
			players[steamid] = {}
		players[steamid][popupname] = choice

popups = {}
popups['optionsmenu'] = popuplib.easymenu('optionsmenu', None, navmenu)
popups['optionsmenu'].settitle('Options')
popups['optionsmenu'].addoption('gotoknifemenu', 'Knifing')
popups['optionsmenu'].addoption('gotosprintmenu', 'Sprinting')
popups['optionsmenu'].addoption('gotospawnmenu', 'Spawning')

popups['knifemenu'] = popuplib.easymenu('knifemenu', None, navmenu)
popups['knifemenu'].settitle('Options>Knifing')
popups['knifemenu'].addoption('gotoknifemsgmode', 'Message Delivery')
popups['knifemenu'].addoption('gotoknifesounds', 'Warning Sounds')
popups['knifemenu'].addoption('gotooptionsmenu', 'Back..')

popups['sprintmenu'] = popuplib.easymenu('sprintmenu', None, navmenu)
popups['sprintmenu'].settitle('Options>Sprinting')
popups['sprintmenu'].addoption('gotosprintmsgs', 'Messages')
popups['sprintmenu'].addoption('gotosprintmsgmode', 'Message Delivery')
popups['sprintmenu'].addoption('gotosprintsounds', 'Sprinting Sounds')
popups['sprintmenu'].addoption('gotooptionsmenu', 'Back..')

popups['spawnmenu'] = popuplib.easymenu('spawnmenu', None, navmenu)
popups['spawnmenu'].settitle('Options>Spawning')
popups['spawnmenu'].addoption('gotospawnlook', 'View Enemy Goals')
popups['spawnmenu'].addoption('gotooptionsmenu', 'Back..')

popups['knifemsgmode'] = popuplib.easymenu('knifemsgmode', None, setoption)
popups['knifemsgmode'].settitle('Options>Knifing>Message Delivery')
popups['knifemsgmode'].addoption(0, 'Popups on the left')
popups['knifemsgmode'].addoption(1, 'Popups on the bottom-center')
popups['knifemsgmode'].addoption(2, 'Chat messages')
popups['knifemsgmode'].addoption('gotoknifemenu', 'Back..')

popups['knifesounds'] = popuplib.easymenu('knifesounds', None, setoption)
popups['knifesounds'].settitle('Options>Knifing>Warning Sounds')
popups['knifesounds'].addoption(0, 'Enabled')
popups['knifesounds'].addoption(1, 'Disabled')
popups['knifesounds'].addoption(2, 'Enabled only for !knifecount')
popups['knifesounds'].addoption('gotoknifemenu', 'Back..')

popups['sprintmsgs'] = popuplib.easymenu('sprintmsgs', None, setoption)
popups['sprintmsgs'].settitle('Options>Sprinting>Messages')
popups['sprintmsgs'].addoption(0, 'Off')
popups['sprintmsgs'].addoption(1, 'Normal')
popups['sprintmsgs'].addoption(2, 'Extended')
popups['sprintmsgs'].addoption('gotosprintmenu', 'Back..')

popups['sprintmsgmode'] = popuplib.easymenu('sprintmsgmode', None, setoption)
popups['sprintmsgmode'].settitle('Options>Sprinting>Message Delivery')
popups['sprintmsgmode'].addoption(0, 'Popups on the left')
popups['sprintmsgmode'].addoption(1, 'Popups on the bottom-center')
popups['sprintmsgmode'].addoption(2, 'Chat messages')
popups['sprintmsgmode'].addoption('gotosprintmenu', 'Back..')

popups['sprintsounds'] = popuplib.easymenu('sprintsounds', None, setoption)
popups['sprintsounds'].settitle('Options>Sprinting>Sprinting Sounds')
popups['sprintsounds'].addoption(0, 'Enabled')
popups['sprintsounds'].addoption(1, 'Disabled')
popups['sprintsounds'].addoption('gotosprintmenu', 'Back..')

popups['spawnlook'] = popuplib.easymenu('spawnlook', None, setoption)
popups['spawnlook'].settitle('Options>Spawning>View Enemy Goals')
popups['spawnlook'].addoption(0, 'Off')
popups['spawnlook'].addoption(1, 'On')
popups['spawnlook'].addoption('gotospawnmenu', 'Back..')

def load():
	es.msg('#Green', 'Universal Soccer Script On - by Toph')
	if(es.exists('clientcommand', 'options') != 1):
		cmdlib.registerClientCommand('options', optionssay, 'Shows the player options menu')
	if(es.exists('saycommand', '!options') != 1):
		cmdlib.registerSayCommand('!options', optionssay, 'Shows the player options menu')
	loadconfig()
	global isnm
	isnm = 1

def loadadmins():
	admins = config["Admin"]
	adminlist = ""
	if(int(admins['usemani']) == 1):
		es.load('examples/auth/mani_basic_auth')
	if(len(admins) > 1):
		for admin in admins:
			if(admin != "usemani"):
				adminlist = "%s;%s" % (admin, adminlist)
		es.server.cmd('echo \"Setting admins: %s...\"' % adminlist)
		es.set('BASIC_AUTH_ADMIN_LIST', adminlist)
		es.load('examples/auth/basic_auth')

def loadconfig(mapname = ""):
	if(path.exists(es.server_var['eventscripts_gamedir'] + '/cfg/' + mapname + '.ini')):
		getconfig(es.server_var['eventscripts_gamedir'] + '/cfg/' + mapname + '.ini')
	else:
		getconfig(es.server_var['eventscripts_gamedir'] + '/cfg/soccer.ini')
	loadadmins()
	initvars()
	global commentator
	global deaths
	commentator = int(config["Commentator"]["enabled"])
	deaths = int(config["Commentator"]["deaths"])

def unload():
	unloadall()
	savepvars()
	global popups
	for item in popups:
		popups[item].delete()
	popups.clear()
	cmdlib.unregisterClientCommand('options')
	cmdlib.unregisterSayCommand('!options')
	es.msg('#Green', 'Universal Soccer Script Off')

def unloadall():
	if(checkbox in es.addons.TickListeners):
		es.addons.unregisterTickListener(checkbox)
	for script in config['Core']:
		if(int(config['Core'][script]) > 1):
			queue(es.unload, 'soccer/%s%s' % (script.replace('_enabled', '') , config['Core'][script]))
		else:
			queue(es.unload, 'soccer/%s' % script.replace('_enabled', ''))

def es_map_start(event_var):
	global mapname
	global isnm
	isnm = 1
	unloadall()
	mapname = event_var['mapname']
	loadconfig(mapname)
	getcoords(mapname)
	if len(boxes):
		global functions
		functions = {}
	savepvars()
	global spawn_time
	global spawn_queue
	spawn_time = 0
	spawn_queue = []

def toload(scriptname):
	return int(config['Core']['%s_enabled' % scriptname])

def player_death(event_var):
	global newround
	newround = 0
	if(es.getlivingplayercount(2) == 0 or es.getlivingplayercount(3) == 0):
		global roundfinished
		roundfinished = 1
	if(commentator == 1 and deaths == 1 and roundfinished == 0):
		es.msg('#multi', '#greenPlayer#lightgreen %s #greenhas been injured.' % event_var['es_username'])

def rp():
	alivelist = playerlib.getUseridList('#alive,#human')
	if(len(alivelist) != 0):
		randid = int(random.choice(alivelist))
		if(es.exists('userid', randid) == 1):
			return randid
		else:
			return 0

def round_start(event_var):
	global roundfinished
	global newround
	global timer
	timer = time.time()
	roundfinished = 0
	newround = 1
	if(isnm == 1):
		maps = config["Map"]["maps"]
		for map in maps:
			if(map in mapname):
				es.addons.registerTickListener(checkbox)
				es.msg('#Green', 'This server is running Universal Soccer Script v%s by Toph.' % es.server_var['uss_version'])
				for script in config['Core']:
					if(int(config['Core'][script]) == 1):
						queue(es.load, 'soccer/%s' % script.replace('_enabled', ''))
					elif(int(config['Core'][script]) != 0):
						queue(es.load, 'soccer/%s%s' % (script.replace('_enabled', ''), config['Core'][script]))
				if(toload('soccermap') == 1):
					queue(es.doblock, 'soccer/soccermap/doloop')
				if(toload('soccerautoref') == 1 and int(config['Ref']['refmode']) == 1):
					queue(es.doblock, 'soccer/soccerautoref/startptime')
		global isnm
		isnm = 0
	del slayed[:]

def curtime():
	global timer
	return time.time() - timer

def multipleReplace(text, wordDict):
	for key in wordDict:
		text = text.replace(key, wordDict[key])
	return text

def spawn(userid, param = 0):
	global spawn_time
	dead = es.getplayerprop(userid, "CBasePlayer.pl.deadflag")
	if int(param) == 0 or not dead:
		es.setplayerprop(userid, "CCSPlayer.m_iPlayerState", 0)
		es.setplayerprop(userid, "CCSPlayer.baseclass.m_lifeState", 512)
		if spawn_time == 0:
			time = 0.05
		else:
			diff = curtime() - spawn_time
			if diff <= 0:
				time = -diff
			else:
				time = 0.05
		time += 0.15
		delayed(time, es.spawnplayer, userid)
		spawn_time = time + curtime()

def initvars():
	global roundfinished
	global newround
	global players
	global refvars
	global stats
	global slayed
	roundfinished = 0
	newround = 0
	for cvar in config['Core']:
		es.set(cvar, config['Core'][cvar])
		es.makepublic(cvar)
	slayed = []
	players = {}
	refvars = {}
	stats = {}
	stats['@Restricted'] = []
	pvarsfile = es.getAddonPath('soccer') + '/playervars.cpickle'
	if(path.exists(pvarsfile)):
		from cPickle import load
		readpvars = open(pvarsfile, 'r')
		players = load(readpvars)
		readpvars.close()
	wordDic = {
	'soccermod 2008': 'UniversalSoccerScript',
	'soccermod 2009': 'UniversalSoccerScript',
	'soccer mod 2008': 'Universal Soccer Script',
	'soccer mod 2009': 'Universal Soccer Script',
	'soccermod': 'UniversalSoccer',
	'soccer mod': 'Universal Soccer'}
	hostname = es.getString('hostname').lower()
	if('soccer' in hostname and 'mod' in hostname):
		es.set('hostname', multipleReplace(hostname, wordDic))

def restrictstat(name):
	if(name not in stats['@Restricted']):
		stats['@Restricted'].append(name)

def unrestrictstat(name):
	if(name not in stats['@Restricted']):
		return False
	else:
		stats['@Restricted'].remove(name)
		return True

def addsound(sound):
	es.stringtable('downloadables', 'sound/' + sound)

def adddownloads(downloads):
	for download in downloads:
		es.stringtable('downloadables', download)

def slay(userid):
	admins = config["Admin"]
	slaysteamid = es.getplayersteamid(userid)
	if(slaysteamid in admins):
		if(int(admins[slaysteamid]['donotslay']) == 1):
			es.msg('#multi', '#greenPlayer#lightgreen %s #greenwas not slayed due to admin privileges.' % es.getplayername(userid))
		else:
			es.emitsound("player", userid, "weapons/hegrenade/explode3.wav", '1.0', '0.6')
			es.sexec(userid, 'kill')
			if(int(config["Respawn"]["respawnslayed"]) == 0):
				slayed.append(slaysteamid)
	else:
		es.emitsound("player", userid, "weapons/hegrenade/explode3.wav", '1.0', '0.6')
		es.sexec(userid, 'kill')
		if(int(config["Respawn"]["respawnslayed"]) == 0):
			slayed.append(slaysteamid)

def savepvars():
	from cPickle import dump
	writepvars = open(es.getAddonPath('soccer') + '/playervars.cpickle', 'w')
	dump(players, writepvars)
	writepvars.close()

def incstat(steamid, name, stat):
	if(steamid not in stats):
		stats[steamid] = {}
		stats[steamid]['Name'] = name
		stats[steamid][stat] = 1
	elif(stat not in stats[steamid]):
		stats[steamid][stat] = 1
	elif(stats[steamid][stat] != 0):
		stats[steamid][stat] += 1
	else:
		stats[steamid][stat] = 1

def dofire(p1, p2, p3, p4 = "", p5 = ""):
	es.server.cmd('es_xfire %i %s %s [%s] [%s]' % (p1, p2, p3, p4, p5))

def getconfig(filename):
	from configobj import ConfigObj
	global config
	config = ConfigObj(filename)

def hook(function, name):
	if name not in functions:
		functions[name] = []
	functions[name].append(function)

def firefunc(name, args):
	if name in functions:
		for func in functions[name]:
			func(args)

def checkbox():
	for userid in es.getUseridList():
		for box in boxes:
			if(str(playerlib.getPlayer(userid).isdead) in str(box.dead) and str(es.getplayerteam(userid)) in str(box.team) and es.getplayerlocation(userid) in box):
				firefunc(box.name, userid)

class Box:
	def __init__(self, dead, team, name, mincoord, maxcoord):
		self.dead = dead
		self.team = team
		self.name = name
		self.mincoord = mincoord
		self.maxcoord = maxcoord
	def __contains__(self, location):
		if(vecmath.isbetweenRect(location, self.mincoord, self.maxcoord)):
			return True

def getcoords(mapname):
	mapcoords = config["MapCoords"]
	for mcmapname in mapcoords:
		if(mcmapname == mapname):
			setcoords(mapcoords[mcmapname])
		elif("ka_soccer_20" in mapname):
			if("2007" in mapname):
				setcoords(mapcoords["2007"])
			elif("_sansiro" in mapname):
				setcoords(mapcoords["_sansiro"])
			else:
				setcoords(mapcoords["ka_soccer_20"])
		elif("_acssl_2010" in mapname):
			setcoords(mapcoords["_acssl_2010"])
		elif("_acssl_2009" in mapname):
			setcoords(mapcoords["_acssl_2009"])
		else:
			setcoords(mapcoords["default"])

def setcoords(thismap):
	global goalhp
	global goaldisty
	global pbx
	global pbz
	global pbcty
	global pbty
	global newpbcty
	global newpbty
	global halfline
	global ballname
	global tgoalviewx
	global tgoalviewy
	global ctgoalviewx
	global ctgoalviewy
	global goalviewz
	global cheerx
	global cheery
	global cheerz
	global cheerdirection
	global cheeramount
	global boxes
	global bins
	global bin1telex
	global bin1teley
	global bin2telex
	global bin2teley
	global bin1viewx
	global bin1viewy
	global bin2viewx
	global bin2viewy
	global bin1viewx2
	global bin1viewy2
	global bin2viewx2
	global bin2viewy2
	global b1xm
	global b1xp
	global b2xm
	global b2xp
	global b1ym
	global b1yp
	global b2ym
	global b2yp
	global binym
	global binyp
	global binz
	global binviewz
	global binviewz1
	global binviewz2
	global tspawnxm
	global tspawnxp
	global ctspawnxm
	global ctspawnxp
	global spawnym
	global spawnyp
	global spawnz
	global biggoals
	global ingoals
	boxes = []
	soccerautoref_enabled = int(config["Core"]["soccerautoref_enabled"])
	soccergoalie_enabled = int(config["Core"]["soccergoalie_enabled"])
	soccergoalslay_enabled = int(config["Core"]["soccergoalslay_enabled"])
	soccerstats_enabled = int(config["Core"]["soccerstats_enabled"])
	healthmode = int(config["Health"]["healthmode"])
	spawnmode = int(config["Respawn"]["spawnmode"])
	goalhp = int(thismap['goalhp'])
	ballname = str(thismap['ballname'])
	if(soccerautoref_enabled != 0 or soccergoalie_enabled != 0):
		goaldisty = float(thismap['goaldisty'])
		pbx = float(thismap['pbx'])
		pbz = float(thismap['pbz'])
		pbty = float(thismap['pbty'])
		pbcty = float(thismap['pbcty'])
	if(healthmode > 2):
		tgoalviewx = float(thismap['tgoalviewx'])
		tgoalviewy = float(thismap['tgoalviewy'])
		ctgoalviewx = float(thismap['ctgoalviewx'])
		ctgoalviewy = float(thismap['ctgoalviewy'])
		goalviewz = float(thismap['goalviewz'])
		if(spawnmode < 3):
			bins = int(thismap['bins'])
			bin1telex = float(thismap['bin1telex'])
			bin1teley = float(thismap['bin1teley'])
			bin2telex = float(thismap['bin2telex'])
			bin2teley = float(thismap['bin2teley'])
			bin1viewx = float(thismap['bin1viewx'])
			bin1viewy = float(thismap['bin1viewy'])
			bin2viewx = float(thismap['bin2viewx'])
			bin2viewy = float(thismap['bin2viewy'])
			bin1viewx2 = float(thismap['bin1viewx2'])
			bin1viewy2 = float(thismap['bin1viewy2'])
			bin2viewx2 = float(thismap['bin2viewx2'])
			bin2viewy2 = float(thismap['bin2viewy2'])
			binviewz = float(thismap['binviewz'])
			binviewz1 = float(thismap['binviewz1'])
			binviewz2 = float(thismap['binviewz2'])
			b1xm = float(thismap['b1xm'])
			b1xp = float(thismap['b1xp'])
			b2xm = float(thismap['b2xm'])
			b2xp = float(thismap['b2xp'])
			b1ym = float(thismap['b1ym'])
			b1yp = float(thismap['b1yp'])
			b2ym = float(thismap['b2ym'])
			b2yp = float(thismap['b2yp'])
			binym = float(thismap['binym'])
			binyp = float(thismap['binyp'])
			binz = float(thismap['binz'])
			tspawnxm = float(thismap['tspawnxm'])
			tspawnxp = float(thismap['tspawnxp'])
			ctspawnxm = float(thismap['ctspawnxm'])
			ctspawnxp = float(thismap['ctspawnxp'])
			spawnym = float(thismap['spawnym'])
			spawnyp = float(thismap['spawnyp'])
			spawnz = float(thismap['spawnz'])
	if(int(config["Map"]["cheerleaders_enabled"]) != 0):
		cheerx = float(thismap['cheerx'])
		cheery = float(thismap['cheery'])
		cheerz = float(thismap['cheerz'])
		cheerdirection = float(thismap['cheerdirection'])
		cheeramount = float(thismap['cheeramount'])
	if(soccergoalie_enabled != 0 or soccerstats_enabled == 1):
		halfline = float(thismap['halfline'])
		biggoals = {'ty': [float(thismap['biggoals'][0]), float(thismap['biggoals'][1])], 'cty': [float(thismap['biggoals'][2]), float(thismap['biggoals'][3])], 'x': [float(thismap['biggoals'][4]), float(thismap['biggoals'][5])], 'ty2': [float(thismap['biggoals'][6])], 'cty2': [float(thismap['biggoals'][7])]}
		ingoals = {'ty': [float(thismap['ingoals'][0]), float(thismap['ingoals'][1])], 'cty': [float(thismap['ingoals'][2]), float(thismap['ingoals'][3])], 'x': [float(thismap['ingoals'][4]), float(thismap['ingoals'][5]), float(thismap['ingoals'][6])]}
	if(soccergoalie_enabled == 1):
		boxes.append(Box(float(thismap['thefield'][0]), float(thismap['thefield'][1]), 'thefield', [float(thismap['thefield'][2]),float(thismap['thefield'][3]),float(thismap['thefield'][4])], [float(thismap['thefield'][5]),float(thismap['thefield'][6]),float(thismap['thefield'][7])]))
		boxes.append(Box(float(thismap['goalbox1'][0]), float(thismap['goalbox1'][1]), 'goalbox1', [float(thismap['goalbox1'][2]),float(thismap['goalbox1'][3]),float(thismap['goalbox1'][4])], [float(thismap['goalbox1'][5]),float(thismap['goalbox1'][6]),float(thismap['goalbox1'][7])]))
		boxes.append(Box(float(thismap['goalbox2'][0]), float(thismap['goalbox2'][1]), 'goalbox2', [float(thismap['goalbox2'][2]),float(thismap['goalbox2'][3]),float(thismap['goalbox2'][4])], [float(thismap['goalbox2'][5]),float(thismap['goalbox2'][6]),float(thismap['goalbox2'][7])]))
	if(soccergoalslay_enabled != 0):
		boxes.append(Box(float(thismap['goaltop1'][0]), float(thismap['goaltop1'][1]), 'goaltop1', [float(thismap['goaltop1'][2]),float(thismap['goaltop1'][3]),float(thismap['goaltop1'][4])], [float(thismap['goaltop1'][5]),float(thismap['goaltop1'][6]),float(thismap['goaltop1'][7])]))
		boxes.append(Box(float(thismap['goaltop2'][0]), float(thismap['goaltop2'][1]), 'goaltop2', [float(thismap['goaltop2'][2]),float(thismap['goaltop2'][3]),float(thismap['goaltop2'][4])], [float(thismap['goaltop2'][5]),float(thismap['goaltop2'][6]),float(thismap['goaltop2'][7])]))
	newpbcty = pbcty
	newpbty = pbty
	if(pbcty < pbty):
		newpbcty -= goaldisty
		newpbty += goaldisty
	else:
		newpbcty += goaldisty
		newpbty -= goaldisty