import es
import playerlib
import random
import soccer.soccer as soccerlib
from gamethread import delayed
import psyco
psyco.full()

info = es.AddonInfo()
info.name = "Soccer Map Script"
info.version = soccerlib.info.version
info.basename = "soccermap"
info.author = "chrismrulz"

crowds_enabled = int(soccerlib.config["Map"]["crowds_enabled"])
tunnels_enabled = int(soccerlib.config["Map"]["tunnels_enabled"])
logos_enabled = int(soccerlib.config["Map"]["logos_enabled"])
flagpoles_enabled = int(soccerlib.config["Map"]["flagpoles_enabled"])
billboards_enabled = int(soccerlib.config["Map"]["billboards_enabled"])
ctflags_enabled = int(soccerlib.config["Map"]["ctflags_enabled"])
tflags_enabled = int(soccerlib.config["Map"]["tflags_enabled"])
ctflags = soccerlib.config["Map"]["ctflags"]
tflags = soccerlib.config["Map"]["tflags"]
cheerleaders_enabled = int(soccerlib.config["Map"]["cheerleaders_enabled"])
cheerleaders_model = soccerlib.config["Map"]["cheerleaders_model"]
cheerleaders_animations = soccerlib.config["Map"]["cheerleaders_animations"]
if(cheerleaders_enabled != 0):
	cheerleaders_direction = soccerlib.cheerdirection
	cheerleaders_amount = soccerlib.cheeramount
cheerdistance = 35

def load():
  es.msg('#Green', 'Soccer Map Script On - by Toph')

def es_map_start(event_var):
  if(cheerleaders_enabled != 0):
    es.stringtable('downloadables', cheerleaders_model)
    es.precachemodel(cheerleaders_model)

def genhostage(rp):
  global cheerx
  global cheery
  if(cheerleaders_direction == 0):
    cheerx += cheerdistance
  elif(cheerleaders_direction == 1):
    cheerx -= cheerdistance
  elif(cheerleaders_direction == 2):
    cheery += cheerdistance
  elif(cheerleaders_direction == 3):
    cheery -= cheerdistance
  es.server.queuecmd('es_xentcreate %s prop_dynamic' % rp)
  es.server.queuecmd('es_xfire %s prop_dynamic wake' % rp)
  es.server.queuecmd('es_setindexprop server_var(eventscripts_lastgive) \"CBaseEntity.m_vecOrigin\" \"%s, %s, %s\"' % (cheerx,cheery,cheerz))
  es.server.queuecmd('es_setindexprop server_var(eventscripts_lastgive) \"CBaseEntity.m_nModelIndex\" \"%s\"' % es.precachemodel(cheerleaders_model))
  es.server.queuecmd('es_xfire %s prop_dynamic color \"255 255 255\"' % rp)
  if(cheerleaders_count + 1 < cheerleaders_amount):
    global cheerleaders_count
    cheerleaders_count += 1
    genhostage(rp)
  else:
    delayed(3, preanimate)

def preanimate():
  proplist = es.createentitylist("prop_dynamic")
  for x in proplist:
    animate(x)

def animate(index):
  anicount = 0
  for x in cheerleaders_animations:
    delayed(anicount, es.server.queuecmd, ('es_setindexprop %s \"CBaseAnimating.m_nSequence\" \"%s\"' % (index, int(x))))
    anicount += 1
  delayed(anicount + 1, animate, index)

def unload():
  es.msg('#Green', 'Soccer Map Script Off')

def doloop():
  if(es.getlivingplayercount() > 0):
    changemap()
  else:
    delayed(1, doloop)

def changemap():
  rp = soccerlib.rp()
  if(rp != 0):
    if(crowds_enabled == 0):
      soccerlib.dofire(rp, 'crowds','toggle')
      if(tunnels_enabled == 0):
        soccerlib.dofire(rp, 'tunnels','toggle')
      else:
        soccerlib.dofire(rp, 'tunnels2','toggle')
    if(logos_enabled == 1):
      soccerlib.dofire(rp, 'logos','toggle')
    else:
      soccerlib.dofire(rp, 'lights','turnoff')
    if(flagpoles_enabled == 1):
      soccerlib.dofire(rp, 'flagpoles','toggle')
    if(billboards_enabled == 1):
      soccerlib.dofire(rp, 'billboards','toggle')
    if(ctflags_enabled == 1):
      soccerlib.dofire(rp, 'flags_ct','toggle')
    if(tflags_enabled == 1):
      soccerlib.dofire(rp, 'flags_t','toggle')
    if(ctflags != ""):
      soccerlib.dofire(rp, 'flags_%s_ct' % ctflags,'toggle')
    if(tflags != ""):
      soccerlib.dofire(rp, 'flags_%s_t' % tflags,'toggle')

def round_start(event_var):
  if(cheerleaders_enabled != 0):
    global cheerleaders_count
    global cheerx
    global cheery
    global cheerz
    cheerleaders_count = 0
    cheerx = soccerlib.cheerx
    cheery = soccerlib.cheery
    cheerz = soccerlib.cheerz
    rp = soccerlib.rp()
    if(rp != 0):
      genhostage(rp)
  if(logos_enabled == 0):
    rp = soccerlib.rp()
    if(rp != 0):
      soccerlib.dofire(rp, 'lights','turnoff')